// (C) 2003-2015 Doctor Web. All rights reserved.

#ifndef DRWEB_NETCHECK_SCANNER_H
#define DRWEB_NETCHECK_SCANNER_H

#include <vector>

#include "drweb_netcheck_api.h"

class scanner_t : public netcheck_api_t::delegate_t
{
public:
    explicit scanner_t(const std::shared_ptr<netcheck_api_t>& api);

    void start(const std::vector<std::string>& files);

private:
    void send_init();

    void send_data();

private:
    // netcheck_api_t::delegate_t
    void on_scan_report(uint32_t job_id, const nc::ScanReport& report) override final;
    void on_cured_data_size(uint32_t job_id, off_t size) override final;
    void on_cured_data(uint32_t job_id, const void* data, size_t size) override final;
    void on_alarm(uint32_t job_id, dw::ErrorCode ec) override final;
    void on_window_replenished() override final;

    struct job_t {
        const char* file;
        int fd;
        off_t cured_size;
    };

    std::vector<std::string> files_;
    std::map<uint32_t, job_t> jobs_;
    std::shared_ptr<netcheck_api_t> api_;
};

#endif // DRWEB_NETCHECK_SCANNER_H
